#ifndef GANGU_BINARY_PARSER_HPP
#define GANGU_BINARY_PARSER_HPP

namespace boost { namespace spirit {

namespace {

template<int N>
struct read_binary
{
	template<class ScannerT>
	static inline
	void do_( ScannerT &scan, char *buf )
	{
		// non checked...
		*buf = *scan;
		read_binary<N-1>::do_( ++scan, ++buf );
	}
};

template<>
struct read_binary<0>
{
	template<class ScannerT>
	static inline
	void do_( ScannerT &scan, char *buf ){}
};

template<class T>
struct binary_parser_impl : parser<binary_parser_impl<T> >
{
	typedef binary_parser_impl<T> self_t;

	enum{
		NUM_LOOP = sizeof(T)
	};

	template<class ScannerT>
	struct result
	{
		typedef typename match_result<ScannerT, T>::type type;
	};

	template<class ScannerT>
	typename parser_result<self_t,ScannerT>::type
	parse(ScannerT const &scan) const
	{
		char buffer[NUM_LOOP];
		T ret;
		typename ScannerT::iterator_t save = scan.first;

		read_binary<NUM_LOOP>::do_( scan, &(buffer[0]) );
		ret = *(reinterpret_cast<T* >(buffer));
		return scan.create_match(NUM_LOOP, ret, save, scan.first);
	}
};

} //unnamed

template<class T>
struct binary_parser : parser<binary_parser<T> >
{
	typedef binary_parser<T> self_t;

	template<class ScannerT>
	struct result
	{
		typedef typename match_result<ScannerT, T>::type type;
	};

	template<class ScannerT>
	typename parser_result<self_t,ScannerT>::type
	parse(ScannerT const& scan) const
	{
		typedef typename parser_result<self_t,ScannerT>::type result_t;
		return impl::contiguous_parser_parse<result_t>( binary_parser_impl<T>(), scan, scan );
	}
};
} //spilit
} //boost
#endif
