#ifndef GANGU_RETURN_HEAP_PARSER
#define GANGU_RETURN_HEAP_PARSER

namespace boost {

namespace spirit {

template<class ParserT>
struct return_heap_parser
	:unary< ParserT, parser<return_heap_parser<ParserT> > >
{
	typedef return_heap_parser<ParserT> self_t;
	typedef unary<ParserT, parser<self_t> > base_t;

	template<class ScannerT>
	struct result
	{
		typedef typename match_result<ScannerT, boost::shared_ptr<void> >::type type;
	};

	return_heap_parser( ParserT const &p )
		:base_t(p)
	{
	}

	template<class ScannerT>
	typename parser_result<self_t,ScannerT>::type
	parse( ScannerT const &scan )const
	{
		typedef boost::shared_ptr<void> result_t;
		typedef typename parser_result<ParserT,ScannerT>::type sub_t;
		typedef typename sub_t::attr_t attr_t;

		sub_t hit = this->subject().parse(scan);
		if( hit ){
			return scan.create_match( hit.length(), result_t(new attr_t(hit.value())),
				scan.first, scan.first );
		}
		else{
			return scan.no_match();
		}
	}

};

template<class ParserT>
return_heap_parser<ParserT> heap_p( ParserT const &p )
{
	return return_heap_parser<ParserT>(p);
}

}//spirit
}//boost

#endif
