#ifndef GANGU_VECTOR_PARSER
#define GANGU_VECTOR_PARSER

namespace boost {
namespace spirit {


template<class ParserT, size_t Size>
struct vector_parser
	:unary<ParserT, parser<vector_parser<ParserT,Size> > >
{
	typedef vector_parser<ParserT,Size> self_t;
	typedef unary<ParserT,parser<self_t> > base_t;
	
	template<class ScannerT>
	struct result
	{
		typedef typename parser_result<ParserT,ScannerT>::type::attr_t attr_t;
		typedef boost::array<attr_t,Size> array_t;
		typedef typename match_result<ScannerT,array_t>::type type;
	};

	vector_parser( ParserT const &p )
		:base_t(p)
	{
	}

	template<class ScannerT>
	typename parser_result<self_t,ScannerT>::type
	parse( ScannerT const &scan )const
	{
		typedef typename result<ScannerT>::array_t array_t;
		typedef typename array_t::value_type value_t;
		typename ScannerT::iterator_t save = scan.first;

		array_t result;

		for( int i = 0; i < Size ; ++i ){
            typename parser_result<ParserT,ScannerT>::type hit = this->subject().parse(scan);
			if( hit.operator_bool() == false ){
				if( i == 0 ){
					std::cout << std::string( scan.first, scan.first + 20 );
					return scan.no_match();
				}
				break;
			}
			result[i] = (value_t)(hit.value());
		}
		return scan.create_match( scan.first - save, result, scan.first, scan.first );
	}
};

template<size_t Size, class ParserT>
vector_parser<ParserT,Size> vector_p( ParserT const &p )
{
	return vector_parser<ParserT,Size>( p );
}

}//spirit
}//boost
#endif
