#include "../include/config.hpp"
#include "../include/blender.hpp"
#include "../include/ObjectParser.hpp"

namespace MQO {


void ObjectParser::buildHierarchy( ObjectParser::hierarchy_t const &hierarchy )const
{
	hierarchy_t::const_iterator it, ite;
	hierarchy_t::const_reverse_iterator cur, rend;
	
	it = hierarchy.begin();
	ite = hierarchy.end();
	rend = hierarchy.rend();

	for( ; it != ite ; ++it ){
		py::object mesh = it->second.attr("getData")(0,1);
		py::object invmat = it->second.attr("getInverseMatrix")();
		mesh.attr("transform")(invmat);

		if( it->first == 0 )
			continue;
		cur = hierarchy_t::const_reverse_iterator(it);
		while( cur != rend ){
			if( cur->first < it->first ){
				py::list child = py::list( py::make_tuple( it->second ));
				cur->second.attr("makeParent")( child );
				break;
			}
			++cur;
		}
	}
}

}//MQO
